// 29/12/2006
// http://psp.jim.sh/pspsdk-doc/

#include <pspkernel.h>
#include <pspctrl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "graphics.h"

PSP_MODULE_INFO("mandel JMF", 0x1000, 1, 1);
PSP_MAIN_THREAD_ATTR(0);

#define xmin -2.0
#define xmax 1.0
#define ymin -1.5
#define ymax 1.5

void nextname(char *base)
{char s[52];
 int fcpt=0;
 SceUID f;
 do {sprintf(s,"ms0:/%s%d.dat",base,fcpt);
     f=sceIoOpen(s,PSP_O_RDONLY,0777);
     if (f>0) {sceIoClose (f);fcpt++;}          // f>=3 if file exists
 } while (f>0);
 sprintf(base,"%s",s);
}

int main(void)
{
  SceCtrlData pad;
  int cpt=0,i,ix,iy;
  double x,y,xt,yt,tmp;
  SceUID f;
  char s[42];

  SetupCallbacks();                         // ajout anti-freeze (cf web)
  InitializeGraphics(1);		//  2 bytes/pixel && 512 instead of 480
//  memset((char*)0x44000000,0,512*272*2);  			// blank screen 
  sprintf(s,"mandel");nextname(s);
  f=sceIoOpen(s,PSP_O_WRONLY|PSP_O_CREAT,0777);
  for (iy=0;iy<272;iy++) 
    for (ix=0;ix<480;ix++) {
       cpt=0;
       x=(xmax-xmin)/480.*(double)ix+xmin;
       y=(ymax-ymin)/272.*(double)iy+ymin;
       xt=x;yt=y;
       do {tmp=xt*xt-yt*yt+x;yt=2.*xt*yt+y;xt=tmp;cpt++;}  	// z -> z^2+c
          while (((xt*xt+yt*yt)<4)&&(cpt<16));   		// R=sup(|c|,2)
       if (cpt==0) cpt=1;
       PlotPixel(ix,iy,cpt*16-1,cpt*16-1,cpt*16-1);
       sceIoWrite(f,&cpt,1);
  }
  PlotPixel(1,1,255,255,255);
  sceIoClose(f);
  do {sceCtrlReadBufferPositive(&pad, 1); sceDisplayWaitVblankStart();}
     while (!(pad.Buttons & PSP_CTRL_CROSS));
  sceKernelExitGame();
  return 0;
} 

//////////////////////////////////////////////////////////
// http://www.psp-programming.com/tutorials/c/lesson02.htm
//////////////////////////////////////////////////////////
/* Exit callback */
int exit_callback(int arg1, int arg2, void *common) {
 sceKernelExitGame();return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp) {
 int cbid;

 cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
 sceKernelRegisterExitCallback(cbid);
 sceKernelSleepThreadCB();
 return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void) {
 int thid = 0;

 thid=sceKernelCreateThread("update_thread",CallbackThread,0x11,0xFA0,0,0);
 if(thid >= 0) {sceKernelStartThread(thid, 0, 0);}
 return thid;
} 
