// 26/12/2006
// http://psp.jim.sh/pspsdk-doc/

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspdisplay.h>
#include <pspsdk.h>
#include <pspctrl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <psppower.h>
#include <math.h>
#include <png.h>
#include "graphics.h"

PSP_MODULE_INFO("GPS JMF", 0x1000, 1, 1); // 1000 = set kernel mode
PSP_MAIN_THREAD_ATTR(0);

#define printf pspDebugScreenPrintf

void nextname(char *base)
{char s[52];
 int fcpt=0;
 SceUID f;
 do {sprintf(s,"ms0:/%s%d.dat",base,fcpt);
     f=sceIoOpen(s,PSP_O_RDONLY,0777);
     if (f>0) {sceIoClose (f);fcpt++;} 		// f>=3 if file exists
 } while (f>0);
 sprintf(base,"%s",s);
}

int main(void)
{
  SceCtrlData pad;
  int bauds[7]={1200,2400,4800,9600,19200,38400,57600};
  int cpt=2,ch,fcpt=0,flag=0,ilat,ilon,i;
  double flat,flon,oflat=0.,oflon=0.,mag=128.,degla,deglo;
  char sauv=0,s[52],lat[16],lon[16],txt=1;
  SceUID f,scr;

  SetupCallbacks();                         // ajout anti-freeze (cf web)
  pspDebugScreenInit();                     // init text mode
  pspDebugScreenSetTextColor (0xffffffff);  // White
  pspDebugScreenPrintf("[] and O to change baud rate, ^ to toggle save\n");
  pspDebugScreenPrintf("UP to toggle txt/graphic mode, X to validate and quit");
  pspDebugScreenSetXY(1,6);
  pspDebugScreenPrintf("Select: clear screen\n");
  pspDebugScreenPrintf("Start: dump screen\n");
  pspDebugSioInit();                        // init RS232
  while (1) {
     pspDebugScreenSetXY(1,3);
     pspDebugScreenPrintf("baud=%d  \tsave=%d \ttxt=%d ",bauds[cpt],sauv,txt);
     sceCtrlPeekBufferPositive(&pad, 1); 
     if (pad.Buttons & PSP_CTRL_SQUARE) {cpt++;if (cpt>6) cpt=0;}
     if (pad.Buttons & PSP_CTRL_CIRCLE) {cpt--;if (cpt<0) cpt=6;}
     if (pad.Buttons & PSP_CTRL_TRIANGLE) {sauv=1-sauv;}
     if (pad.Buttons & PSP_CTRL_UP) {txt=1-txt;}
     if (pad.Buttons & PSP_CTRL_CROSS) {break;}
     sceKernelDelayThread(200000); // delay 200 ms = debounce
  }
  printf("\n");
/* 
// write dummy file
  f=sceIoOpen("ms0:/gps0.dat",PSP_O_WRONLY|PSP_O_CREAT,0777);
  for (i=32;i<127;i++) {sceIoWrite(f,&i,1);printf("%c",i);} 
  sceIoClose(f); printf("\n");
// read dummy file
  ch=0;
  f=sceIoOpen("ms0:/gps0.dat",PSP_O_RDONLY,0777);
  do {res=sceIoRead(f,&i,1);printf("%c",i);ch++;} while ((res!=0)&&(ch<100));
  sceIoClose(f); printf("\n");
*/
// let's start
  if (sauv==1) {sprintf(s,"gps"); nextname(s);	// returns in s the new filename
                f=sceIoOpen(s,PSP_O_WRONLY|PSP_O_CREAT|PSP_O_APPEND,0777);}

  pspDebugSioSetBaud(bauds[cpt]);
  printf("\nPSP GPS JMF test");
  if (sauv==1) pspDebugScreenPrintf(": saving in %s\n",s); else
               pspDebugScreenPrintf("\n");
  sceKernelDelayThread(1000000); 	// delay 1 s

  if (txt==0) {
    InitializeGraphics(1);		//  2 bytes/pixel && 512 instead of 480
    memset((char*)0x44000000,0,512*272*2);  			// blank screen 
    }
  cpt=0;fcpt=0;
  while(1) {
           ch = pspDebugSioGetchar();	// get new RS232 char
           if ((ch >= 0) && (ch != '\r')) {
	        if (sauv==1) {sceIoWrite(f,&ch,1);}		// save in File
                if (txt==1) {pspDebugScreenPrintf("%c", ch);}	// print
                if (((ch=='G')||(ch=='P')||(ch=='A')||(flag>99))) flag++; 
                                                                  else flag=0;
                if (flag==5) {flag=100;fcpt=0;}                 // on a eu GPGGA
                if ((flag>112) && (flag<122)) {lat[flag-113]=ch;}
                if ((flag>124) && (flag<135)) {lon[flag-125]=ch;}
                if (flag==135) {                     	// fini parsing $GPGGA
                        lat[9]=0;lon[10]=0;		// end of string
                        flat=atof(lat);flon=atof(lon);
			degla=floor(flat/100.)*100.; 
			deglo=floor(flon/100.)*100.;
			flat=degla+(flat-degla)/60.*100.; // 0..60 -> 0..100 lat
			flon=deglo+(flon-deglo)/60.*100.; // 0..60 -> 0..100 lon
                        if ((oflat==0.) && (oflon==0.))
                             {oflat=flat;oflon=flon;}   // init pos
			ilat=(int)(floor((flat-oflat)*mag))+136;
			ilon=(int)(floor((flon-oflon)*mag))+240;
                        if (txt==1) 
          {printf("\n -> %lf/%lf %lf/%lf mag=%lf\n",flat,oflat,flon,oflon,mag);}
                        else 
                          if ((ilat>0) && (ilat<272) && (ilon>0) && (ilon<480)) 
                              PlotPixel(ilon,271-ilat,255,255,255);
                        flag=0;}
           }
           sceCtrlPeekBufferPositive(&pad, 1);  	// DON'T wait VSync
           if (pad.Buttons & PSP_CTRL_CROSS) {break;    }
           if (fcpt==0) {
               if (pad.Buttons & PSP_CTRL_LEFT)   {oflon-=10.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_RIGHT)  {oflon+=10.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_UP)     {oflat+=10.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_DOWN)   {oflat-=10.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_SQUARE) {mag*=2.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_CIRCLE) {if (mag>1) mag/=2.;fcpt=1;}
               if (pad.Buttons & PSP_CTRL_SELECT) {
                   memset((char*)0x44000000,0,512*272*2);	// blank screen
                   oflat=0.;oflon=0.;}
               if (pad.Buttons & PSP_CTRL_START) {
                   sprintf(s,"dump"); nextname(s);  // returns the new filename
                   scr=sceIoOpen(s,PSP_O_WRONLY|PSP_O_CREAT|PSP_O_APPEND,0777);
                   sceIoWrite(scr,lat,9);	                 // dump screen	
                   sceIoWrite(scr,lon,10);
                   for (i=0;i<272;i++) {
                      sceIoWrite(scr,(char*)(0x44000000+2*i*512),480*2);// line
                      PlotPixel(1,i,155,155,155);}
                   sceIoClose(scr);
                   // screenshot("ms0:/d.png");
               }
           }
  }
  if (sauv==1) sceIoClose(f);
  if (txt==1) pspDebugScreenPrintf("Good bye");
  sceKernelExitGame();
  return 0;
} 

//////////////////////////////////////////////////////////
// http://www.psp-programming.com/tutorials/c/lesson02.htm
//////////////////////////////////////////////////////////
/* Exit callback */
int exit_callback(int arg1, int arg2, void *common) {
 sceKernelExitGame();return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp) {
 int cbid;

 cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
 sceKernelRegisterExitCallback(cbid);
 sceKernelSleepThreadCB();
 return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void) {
 int thid = 0;

 thid=sceKernelCreateThread("update_thread",CallbackThread,0x11,0xFA0,0,0);
 if(thid >= 0) {sceKernelStartThread(thid, 0, 0);}
 return thid;
} 
